<'
import shr_chkcov/e/shr_chkcov_top;  // must be imported before all checkers

struct packet {
   color: [RED, GREEN, BLUE];
   kind: [GOOD, BAD];
   keep kind==GOOD;
   
   event ev_packet1;
   event ev_packet2;
   event ev_packet3;
   expect my_expect is @ev_packet1 => @ev_packet2;
   expect another_expect is @ev_packet3 => @ev_packet2;
   expect @ev_packet1 exec {print "packet1"} => @ev_packet2 exec {print "packet2"};
   expect or_expect is @ev_packet1 => @ev_packet2 or @ev_packet3;
    
   packet_tcm() @sys.any is {
      emit ev_packet1;
      wait;
      emit ev_packet2;
      if color==RED {check that kind==GOOD};
      if kind==GOOD {check that color==RED or color==GREEN};
      wait [100];
      stop_run();
   };
}; 

extend RED packet {
   expect red_p is @ev_packet1 => @ev_packet2;
};

extend GREEN packet {
   expect my_expect is only @ev_packet3 exec {print "expect is only in green packet"} => @ev_packet1;
};


unit top_env {
   p1: packet;
   keep p1.color==RED;
   p2: packet;
   keep p2.color==GREEN;
   
   run() is also {
      //gen p;
      start p1.packet_tcm();
      start p2.packet_tcm();
   };
}; // unit top_env


extend sys{
   top: top_env is instance;
};
'>

